#if !defined(__change_h)
#define __change_h

#include <vector.h>

class CChange
{
public:
    CChange();
    void Reset();

    inline bool IsEnabled() { return Enabled; }
    inline void Disable();

    short GetValidSize() { return ValidSize; }
    int IsAfterSign(int Pos);
    inline int GetPosAfterSign();
    short GetChangedSubdoc();

    void SetValidSize(short aValidSize) { ValidSize = aValidSize; }
    void SetSign(int From, int To);
    void ClearSign();
    inline void Push(short Subdoc);
    inline void Pop(); // asserts stack is not empty

private:
    bool Enabled;
    short ValidSize;
    int ChunkFrom;
    int ChunkTo;
    vector<short> Stack;
};

inline void CChange::Disable()
{
    Enabled = false;
    Stack.clear();
}

inline void CChange::Push(short Subdoc)
{
    Assert(Subdoc > 0);
    Stack.push_back(Subdoc);
}

inline void CChange::Pop()
{
    Assert(Stack.size() > 0);
    Stack.pop_back();
}

inline int CChange::GetPosAfterSign()
{
    return ChunkTo + 1; // ChunkTo == -1 => returns 0
}

#endif
