#if !defined(__dynstem_h)
#define __dynstem_h

#include "abststem.h"

class CLocusOptions;

class CDynamicStemmer : public CAbstractStemmer
{
public:
    CDynamicStemmer(CLocusOptions &Options);
    virtual ~CDynamicStemmer();

    virtual int Apply(DString &WordForm);

private:
    typedef void (*FGeneric)();
    void *Lib;
    DString DlsymErrMsgFormat;

    void *Stemmer;
    FGeneric ApplyProc;
    FGeneric DoneProc;

    void InitLib(const DString &LibName,
	const DString &ErrMsgFormat);
    FGeneric GetFncAddr(const char *FncName);

    void Done();

    DString GetLibraryName(const DString &StemImpl);
};

#endif
