#if !defined(__filebase_h)
#define __filebase_h

#include "recbase.h"
#include "tl.h"
#include "docdesc.h"
#include "locusopt.h"

class CFBDual;

class CFileBase
{
public:
    struct SFileRecord
    {	ulong FirstWord;
	ulong	WordCount;
    };

// data members
private:
    CFBDual *BaseIndex;
    CRecBase *BaseData;
    CBook *FirstWordTree;

public:
    CFileBase(ushort Opt, CLocusOptions &Options);
    virtual ~CFileBase();

    ulong GetGlobalDelta();
    ulong GetTotalDocCount();

    short Add(const CDocDesc &DocDesc,
	const SFileRecord &Rec,
	ulong &Num);
	// returns 0 OK, Num is output param; 1 document already
        // exists

    short Get(const CDocDesc &DocDesc,
	SFileRecord &Rec,
	ulong &Num);
	// returns 0 OK, Rec & Num are output params; 1 document
        // does not exist

    short Get(ulong Num,
	SFileRecord &Rec,
	CDocDesc &DocDesc);
	// returns 0 OK, Rec & Name are output params; 1 document
        // does not exist

    short GetFirst(CDocDesc &DocDesc,
	SFileRecord &Rec,
	ulong &Num);
	// all params are output
        // returns 0 OK, 1 base is empty

    short GetLast(CDocDesc &DocDesc,
	SFileRecord &Rec,
	ulong &Num);
	// all params are output
        // returns 0 OK, 1 base is empty

    void StoreAll();
    
    short Has(const DString &DocName);

    short GetNum(ulong Occ, ulong &Num);
	// returns 0 OK, 1 Occ is not in any document

    int Advance(CDocDesc &DocDesc);
        // DocDesc is in & out param; on input must
        // identify indexed document.
        // Function returns 0 OK (DocDesc identifies
        // next doc), 1 input was last doc

private:
    CFileBase(CFileBase &Src); // not implemented
    CFileBase & operator = (CFileBase &Src); // not implemented
};

#endif

