#include "myfndt.h"
#include "hdoc.h"
#include "dualmap.h"
#include "ddkey.h"

#include <string.h>

CDualMap *CDocHandler::DualMap = NULL;

CDocHandler::CDocHandler(CDualMap *aDualMap)
{
	Assert(!DualMap);
	DualMap = aDualMap;
}

CDocHandler::~CDocHandler()
{
    delete DualMap;
    DualMap = NULL;
}

KEY CDocHandler::NewKey(const CDocDesc &DocDesc)
{
    CDocDescKey DocDescKey(DocDesc, DualMap);
    CNewKey Key(CKeyHandler::NewKey(CDocDesc::GetDiskLen()));
    DocDescKey.FillKey(Key);
    return Key.Drop();
}

void CDocHandler::GetDocDesc(KEY Key, CDocDesc &DocDesc)
{
    CDocDescKey DocDescKey(Key);
    DocDescKey.FillDocDesc(DualMap, DocDesc);
}

KEY CDocHandler::NewCopy(KEY Key)
{
    ushort len = GetDiskLenReal();
    KEY ret = CKeyHandler::NewKey(len);
    memcpy(ret, Key, len);
    return ret;
}

KEY CDocHandler::Load(KEY, CFileObj *Stream)
{
    ushort len = GetDiskLenReal();
    KEY ret = CKeyHandler::NewKey(len);
    Stream->Read(ret, len);
    return ret;
}

void CDocHandler::Save(KEY, KEY Key, CFileObj *Stream)
{
    Stream->Write(Key, GetDiskLenReal());
}

ushort CDocHandler::GetDiskLen(KEY, KEY)
{
    return GetDiskLenReal();
}

ushort CDocHandler::GetAveDiskLen()
{
    return GetDiskLenReal();
}

ushort CDocHandler::GetAveKeyLen()
{
    return GetDiskLenReal();
}

short CDocHandler::Compare(KEY Key1, KEY Key2)
{
    CDocDescKey DocDescKey1(Key1);
    CDocDescKey DocDescKey2(Key2);
    return DocDescKey1.Compare(DocDescKey2);
}

void CDocHandler::StoreAll()
{
    DualMap->StoreAll();
}

short CDocHandler::Has(const DString &DocName)
{
    return DualMap->Has(DocName);
}

