#include "myfndt.h"
#include "newstem.h"
#include "locusopt.h"
#include "dynstem.h"
#include "ometastm.h"

/* profile 24. 11. 97: creation of dynamic libraries did not measurably
slow indexing (CRS homepage indexed in 26 min) */

CAbstractStemmer *NewStemmer(CLocusOptions &Options)
{
    DString StemLib = Options.Get(O_STEMLIB);
    if (!StemLib.IsEmpty())
    {
#if defined(STATIC_LIBS_ONLY)
        // should not get here
        throw CGeneralException("this version is compiled statically"
            " and does not support dynamic libraries");
#else
        return new CDynamicStemmer(Options);
#endif
    }

    return new CAbstractStemmer();
}
