#include "myfndt.h"
#include "punctaxe.h"

#include <string.h>
    // just for assertions

CPunctAxe::CPunctAxe(const DString &aPunct):
	Punct(aPunct.GetLength(), 0)
{
	int Len = aPunct.GetLength();
	for (int i = 0; i < Len; i++)
		Punct.Add(aPunct[i]);
}

CPunctAxe::~CPunctAxe()
{
}

int CPunctAxe::AxePunct(DString &OccWord)
{
    int s = OccWord.GetLength() + 1;
    CMemPtr<char> Buffer(s);
    memcpy((char *)Buffer, OccWord.c_str(), s);
    char *w = (char *)Buffer;

    while (*w && IsPunct(*w))
        ++w;
    if (!(*w))
        return 1;

    char *e = strchr(w, 0) - 1;
    while (IsPunct(*e))
        *e-- = 0;

    Assert(e >= w);
    OccWord = w;
    return 0;
}

int CPunctAxe::IsPunct(char C)
{
    return Punct.Find(C) != INT_MAX;
}

