#include "cstr.h"
#include "string.h"

const int DString::MaxAllowedLength = 32748;

#if defined(_MSC_VER)
DString::DString()
{
}

DString::DString(const CString &s):
	CString(s)
{
}

DString::DString(const char *cp):
	CString(cp)
{
}
#endif

#if defined(__BORLANDC__)
int DString::operator == (const DString *Other) const
{
	return *this == *Other;
}

int DString::operator < (const DString *Other) const
{
	return *this < *Other;
}

int DString::operator > (const DString *Other) const
{
	return *this > *Other;
}
#endif

unsigned int DString::HashValue() const 
{ 
#if defined(__BORLANDC__)
     return hash(); 
#else
	if (!GetLength())
	     return 0;
	else
	     return operator [](0);
#endif
}

#if defined(_MSC_VER) 
char &DString::operator[](int nIndex)
{
	CopyBeforeWrite();
	return *(const_cast<char *>(const_cast<DString *>(
			this)->operator LPCTSTR()) + nIndex);
}
#endif

#if defined(__GNUG__) && !defined(NATIVE_GPLUSPLUS_STRING_COMPARE)
int DString::operator == (const DString &Other) const
{
    return !strcmp(c_str(), Other.c_str());
}

int DString::operator < (const DString &Other) const
{
    return strcmp(c_str(), Other.c_str()) < 0;
}

int DString::operator > (const DString &Other) const
{
    return strcmp(c_str(), Other.c_str()) > 0;
}

int DString::operator != (const DString &Other) const
{
    return strcmp(c_str(), Other.c_str());
}

int DString::operator <= (const DString &Other) const
{
    return strcmp(c_str(), Other.c_str()) <= 0;
}

int DString::operator >= (const DString &Other) const
{
    return strcmp(c_str(), Other.c_str()) >= 0;
}

#endif
