#include "myfndt.h"
#include "univopt.h"
#include "composed.h"
#include "rferr.h"
#include <algo.h>

CUnivOptions::CUnivOptions():
    LastErrorMessage(NULL),
    ComposedKeys(0)
{
}

CUnivOptions::~CUnivOptions()
{
    if (LastErrorMessage)
        free(LastErrorMessage);
}

char *CUnivOptions::UnknownKeyError(const char *Key)
{
    char *Message = OE_INVALKEY;

    if (LastErrorMessage)
        return Message;

    LastErrorMessage = (char *)malloc(strlen(Message) + 1 + strlen(Key) + 1);
    if (!LastErrorMessage)
        return Message;
    
    strcpy(LastErrorMessage, Message);
    strcat(LastErrorMessage, " ");
    strcat(LastErrorMessage, Key);
    return LastErrorMessage;
}

DString CUnivOptions::FirstInvalidKey()
{
	return DString("");
}

void CUnivOptions::WatchSection(const char *SectName)
{
    Assert(SectName != NULL);

    DString Name = SectName;
    vector<DString>::iterator i = lower_bound(SectList.begin(),
	SectList.end(),
	Name);
    if (i == SectList.end() || !(*i == Name))
	SectList.insert(i, Name);
}

short CUnivOptions::HasSection(const char *SectName)
{
    DString Name;
    if (SectName)
	Name = SectName;
    vector<DString>::const_iterator i = lower_bound(SectList.begin(),
	SectList.end(),
	Name);
    return i != SectList.end() && *i == Name;
}

DString CUnivOptions::GetKey(const char *Section,
    const char *Key) const
{
    if (!ComposedKeys)
	return DString(Key);
    else
	return GetLongOptionKey(DString(Section), Key);
}

void CUnivOptions::ChangeWatchedSections(const CStringListValue &ToList)
{
    SectList.clear();

    CStringListValue::DIterator Itr =
	const_cast<CStringListValue &>(ToList).InitIterator();
    while (const_cast<CStringListValue &>(ToList).IsDereferenceable(Itr))
    {   vector<DString>::iterator j = lower_bound(SectList.begin(),
	    SectList.end(),
	    *Itr);
        if (j == SectList.end() || !(*j == *Itr))
	    SectList.insert(j, *Itr);

	++Itr;
     }
}

char *CUnivOptions::AllocMungedSectionName(char *InSection)
{
    return InSection;
}
